%define debug_package %{nil}

Summary:	AVML - Acquire Volatile Memory for Linux

Packager:	Lawrence R. Rogers (lrr@cert.org)

Vendor:		cert.org
Name:		avml
Version:	0.3.0
Release:	1%{?dist}
URL:		https://github.com/microsoft/avml

License:	MIT

Group:		Applications/Forensics Tools
Source:		%{name}-%{version}.tar.gz

BuildRoot:	%{_tmppath}/rpm-root-%{name}-v%{version}
BuildRequires:	musl-devel musl-gcc cargo curl

%description
AVML is an X86_64 userland volatile memory acquisition tool written in Rust, intended to be deployed as a static binary.
AVML can be used to acquire memory without knowing the target OS distribution or kernel a priori. No on-target compilation or fingerprinting is needed.

Features:
 * Save recorded images to external locations via Azure Blob Store or HTTP PUT
 * Automatic Retry (in case of network connection issues) with exponential backoff for uploading to Azure Blob Store
 * Optional page level compression using Snappy.
 * Uses LiME output format (when not using compression).

Memory Sources
 * /dev/crash
 * /proc/kcore
 * /dev/mem

%prep
%setup 

%build
curl https://sh.rustup.rs -sSf | sh -s -- -y
sh -c "source $HOME/.cargo/env; rustup target add x86_64-unknown-linux-musl"
if ! sh -c "source $HOME/.cargo/env; cargo build --release --target x86_64-unknown-linux-musl" ; then
	rm -rf $(find|grep cfg-if)
	sh -c "source $HOME/.cargo/env; cargo build --release --target x86_64-unknown-linux-musl" 
fi 


%install
%{__install} -Dp -m755 target/x86_64-unknown-linux-musl/release/avml         %{buildroot}%{_bindir}/avml
%{__install} -Dp -m755 target/x86_64-unknown-linux-musl/release/avml-convert %{buildroot}%{_bindir}/avml-convert

%clean
%{__rm} -rf %{buildroot} $HOME/.cargo

%files
%defattr(-, root, root, 0755)
%doc 
%attr(755, root, root)	%{_bindir}/%{name}
%attr(755, root, root)	%{_bindir}/%{name}-convert

%changelog
* Thu Jun 24 2021 Lawrence R. Rogers <lrr@cert.org> 0.3.0-1
* Release 0.3.0-1
	Version 0.3.0

* Tue Dec  1 2020 Lawrence R. Rogers <lrr@cert.org> 0.2.1-1
* Release 0.2.1-1
	Version 0.2.1
	Initial release

